data    segment para
    io8255_c    equ 200h    ;8255pa
    io8255_b    equ 201h    ;8255pb
    io8255_a    equ 202h    ;8255pc
    io8255_k    equ 203h    ;8255ƿ

    io8254_cs   equ 210h    ;8254Ƭѡ
    ad_cs       equ 220h    ;adcƬѡ
    LED_cs      equ 230h    ;ַܻ

    phase       db  01h, 03h, 02h, 06h, 04h, 0ch, 08h, 09h  ;

    disp        db  6dh, 66h, 4fh, 5bh, 06h                 ;״̬
    lamp        db  0ch, 14h, 21h, 22h                      ;ͨ״̬

    turn        db  0        ;
    stop1       db  0        ;ж

    speedh      db  12
    speed       dw  ?        ;ٶ

    tmp         dw  0
    second1     db  0        ;1s ʱ
    second5     dw  0        ;5s ʱ
data    ends

ss_seg    segment para
    dw  100 dup(0)
ss_seg    ends

code    segment para
    assume cs:code, ds:data, ss:ss_seg
    main    proc    far
        cli                 ;رж
        mov     ax, data
        mov     ds, ax
;ʼر
        mov     turn, 1
        mov     speed, 280h
        mov     bx, 0
        mov     di, 0
;ʼ 8254
        mov     dx, io8254_cs ;ѡ״̬ڣ cnt0 óֵ
        add     dx, 3
        mov     al, 00110111b ;ʽ
        out     dx, al
        mov     dx, io8254_cs
        mov     al, 0
        out     dx, al
        out     dx, al ;n<--0
;ʼ8255papbpc
        mov     dx, io8255_k
        mov     al, 10001001b
        out     dx, al
;8259ж
        in      al, 21h
        and     al, 11011011b
        out     21h, al
;8259ж
        in      al, 0a1h
        and     al, 11111110b
        out     0a1h, al
;ж
        push    ds
        mov     ax, 0
        mov     ds, ax
        lea     ax, cs:fenpin
        mov     si, 35h
        add     si, si
        add     si, si
        mov     ds:[si], ax
        push    cs
        pop     ax
        mov     ds:[si+2], ax
        lea     ax, cs:emergency
        mov     si, 70h
        add     si, si
        add     si, si
        mov     ds:[si], ax
        push    cs
        pop     ax
        mov     ds:[si+2], ax
        pop     ds

        sti;жϣʼ

    begin:
        mov     dx, io8255_b
        cmp     turn, 1
        jne     reverse
    normal:
        mov     cx, 8 ;8 ѭ
        lea     si, phase
    loop1:
        mov     al, [si]
        out     dx, al
        call    delay
        inc     si
        loop    loop1
        jmp     light
    reverse:
        mov     cx, 8       ;8 ѭ
        lea     si, phase+7
    loop2:
        mov     al, [si]
        out     dx, al
        call    delay
        dec     si
        loop    loop2

;LED ʾͨ״̬
    light:
        mov     dx, io8255_a
        mov     al, lamp[di]
        out     dx, al
;ʾͨƵʱ
        mov     dx, LED_cs
        mov     al, disp[bx]
        out     dx, al
        mov     dx, LED_cs + 1
        mov     al, 000001b ;дһλ
        out     dx, al
        jmp     begin       ;ѭȴж
    main    endp

;mir5 1s Ƶӳ
    fenpin   proc    far
        cli
        push    ax
        push    dx
        inc     second1
        cmp     second1, 100   ;ÿˢܺ͵״̬
        jne     next
        mov     second1, 0
    shumaguan:              ;ı״̬
        inc     bx
        cmp     bx, 5
        jne     motor
        xor     bx, bx
    motor:                  ;ı״̬
        mov     dx, io8255_c
        in      al, dx
        test    al, 80h
;ת
        jnz     n1
        mov     turn, 0     ;k7 Ϊͣת
        jmp     n2          ;k7 Ϊߣת
    n1:
        mov turn, 1
;ת
    n2:
        mov     dx, ad_cs   ;adc0809
        out     dx, al
        mov     dx, ad_cs   ;ַת״̬
        add     dx, 2
    chaxun:
        in      al, dx
        test    al, 01h     ;ѯ״̬
        jz      chaxun
        mov     dx, ad_cs   ;ַתݿ
        inc     dx
        in      al, dx
        mov     ah, 2
        mov     speed, ax   ;ģת speed Կת
    next:
        cmp     stop1, 1
        je      urg
        inc     second5
        cmp     second5, 500   ;ÿ 5s  ̵
        jne     exit
        mov     second5, 0
        inc     di
        cmp     di, 4
        jne     exit
        xor     di, di
        jmp     exit
    urg:
        mov     tmp, di
        mov     di, 0
        inc     second5
        cmp     second5, 500   ;һʱ
        jne     exit
        mov     stop1, 0
        mov     second5, 0
        mov     di, tmp
    exit:
        mov     al, 20h     ;жϽ 386ex  8259  mir5
        out     20h, al
        pop     dx
        pop     ax
        sti
        iret
    fenpin endp
;sir0жӳ
    emergency   proc    far
        cli
        push    ax
        mov     stop1, 1
        mov     al, 20h     ;жϽ 386ex  8259  mir5
        out     20h, al
        mov     al, 20h     ;жϽ 386ex  8259  sir0
        out     0a0h, al
        pop     ax
        sti
        iret
    emergency   endp
;ӳӳ
    delay proc
        push    ax
        push    cx
        push    dx
        mov     dh, speedh
    d1:
        mov     cx, speed   ;λ speed
    d2:
        loop    d2          ;Ƶת
        dec     dh
        jnz     d1
        pop     dx
        pop     cx
        pop     ax
        ret
    delay endp
code    ends
    end main
